﻿namespace KludgeBox.Godot.Net;

public record NetworkPeer(long Id)
{
    public bool IsServer => Id == 1;
    public bool IsClient => !IsServer;
    public bool IsLocalClient => Id == 0;
    
    
    public static implicit operator NetworkPeer(long id) => new NetworkPeer(id);
    public static implicit operator long(NetworkPeer sender) => sender.Id;
    public static implicit operator int(NetworkPeer sender) => (int)sender.Id;
    
    public override string ToString() => Id.ToString();
}