﻿namespace VectorSurvivors.Events;

public class CharacterAboutToSpawnEvent(Character Character) : CancellableEvent
{
    public Character Character { get; set; } = Character;
}

public readonly record struct CharacterSpawnedEvent(Character Character) : IEvent;

public class CharacterAboutToDespawnEvent(Character Character) : CancellableEvent
{
    public Character Character { get; set; } = Character;
}

public readonly record struct CharacterDespawnedEvent(Character Character) : IEvent;

public class CharacterTakingDamageEvent(Character Character, Damage Damage) : CancellableEvent
{
    public Character Character { get; set; } = Character;
    public Damage Damage { get; set; } = Damage;
}

public readonly record struct CharacterDiedEvent(Character Character, Damage Damage) : IEvent;