﻿using System.Collections.Generic;

namespace VectorSurvivors;

public static class DamageTag
{
    public static readonly string Universal = "universal";
    public static readonly string Contact = "contact";
}

public class Damage
{
    public Character Inflictor { get; set; }
    public double Amount { get; set; }

    public bool IsCritical { get; set; } = false;
    public bool IsSilent { get; set; } = false;// true if damage is not shown
    public bool IsIgnored { get; set; } = false;
    public bool CanBeIgnored { get; set; } = true;
    
    public HashSet<string> Tags { get; } = new();
    
    public Damage(double amount, bool isCritical, bool isSilent, Character inflictor)
    {
        Amount = amount;
        IsCritical = isCritical;
        IsSilent = isSilent;
        Inflictor = inflictor;
    }

    public Damage(double amount)
    {
        Amount = amount;
    }
    
    public Damage(double amount, Character inflictor)
    {
        Amount = amount;
        Inflictor = inflictor;
    }
    
    public void AddTag(string tag)
    {
        Tags.Add(tag);
    }
    
    public void RemoveTag(string tag)
    {
        Tags.Remove(tag);
    }
    
    public bool HasTag(string tag)
    {
        return Tags.Contains(tag);
    }
}