﻿using System;

namespace VectorSurvivors;

public readonly record struct LevelUpInfo(Player Player, Tier Tier);

public record PendingUpgrade(string Name, string Description, Tier Tier, IUpgradable Upgradable, Action ApplyAction, Texture2D Icon = null)
{
    public Color Color => Tier.Color;
    
    
    public void ApplyUpgrade()
    {
        ApplyAction?.Invoke();
        Upgradable.OnUpgrade(this);
    }
}