﻿using Newtonsoft.Json;

namespace VectorSurvivors;

[GlobalClass]
public partial class CharacterData : Resource
{
    [ExportGroup("Info")]
    [Export] public string Name { get; set; } = "Character";
    [Export] public string Description { get; set; } = "Generic character";
    
    
    [ExportGroup("Stats")] 
    [Export] public double MaxHealth { get; set; } = 10;
    [Export] public double HealthRegen { get; set; } = 0;
    [Export] public int XpReward { get; set; } = 1;
    [Export] public int MoneyReward { get; set; } = 1;
    
    
    [ExportGroup("Visuals")]
    [Export] public double Scale { get; set; } = 1;
    [Export] public string SpriteOverridePath { get; set; } = null;
    
    
    [ExportGroup("Movement")]
    [Export] public double MovementSpeed { get; set; } = 250;
    [Export] public double Friction { get; set; } = 0.5;
    [Export] public double AccelerationTime { get; set; } = 0.15;
    [Export] public double RotationSpeed { get; set; } = Mathf.Tau;
    

    [ExportGroup("Attack")] 
    [Export] public double UniversalAttackDamageFactor = 1;
    [Export] public double UniversalAttackSpeedFactor = 1;
    [Export] public double UniversalAttackRangeFactor = 1;
    
    public override string ToString()
    {
        return JsonConvert.SerializeObject(this);
    }
    
    public static CharacterData FromJson(string json)
    {
        return JsonConvert.DeserializeObject<CharacterData>(json);
    }
}