﻿namespace VectorSurvivors;

[GlobalClass]
public abstract partial class CharacterComponent : Resource
{
    #region Lifetime
    public virtual void OnAdded(Character character){}
    public virtual void OnProcess(Character character, double delta){}
    public virtual void OnPhysicsProcess(Character character, double delta){}
    public virtual void OnRemove(Character character){}
    #endregion

    #region Stats
    // Stats
    public virtual void AdjustMaxHealth(Character character, ref double maxHealth){}
    public virtual void AdjustHealthRegen(Character character, ref double value){}
    public virtual void AdjustXpReward(Character character, ref int value){}
    public virtual void AdjustMoneyReward(Character character, ref int value){}
    public virtual void AdjustOrbCollectionRange(Character character, ref double value){}
    
    // Movement
    public virtual void AdjustMovementSpeed(Character character, ref double speed){}
    public virtual void AdjustFriction(Character character, ref double friction){}
    public virtual void AdjustAccelerationTime(Character character, ref double accelerationTime){}
    public virtual void AdjustRotationSpeed(Character character, ref double rotationSpeed){}
    
    // Attack
    public virtual void AdjustUniversalAttackDamageFactor(Character character, ref double factor){}
    public virtual void AdjustUniversalAttackSpeedFactor(Character character, ref double factor){}
    public virtual void AdjustUniversalAttackRangeFactor(Character character, ref double factor){}
    #endregion

    #region Hooks

    public virtual void TakingDamage(Character target, Damage damage){}

    #endregion
}