﻿namespace VectorSurvivors;

[GlobalClass]
public partial class FlyerComponent : CharacterComponent
{
    
    public double MultiplierPerDifficulty { get; set; } = 0.1;
    /// <inheritdoc />
    public override void AdjustMaxHealth(Character character, ref double maxHealth)
    {
        maxHealth *= 0.25;
    }
    
    public override void AdjustRotationSpeed(Character character, ref double rotationSpeed)
    {
        rotationSpeed *= 1 + MultiplierPerDifficulty * World.Difficulty;
    }
    
    public override void AdjustMovementSpeed(Character character, ref double movementSpeed)
    {
        movementSpeed *= 1 + MultiplierPerDifficulty * World.Difficulty;
    }

    /// <inheritdoc />
    public override void AdjustUniversalAttackDamageFactor(Character character, ref double factor)
    {
        factor *= 1 + MultiplierPerDifficulty * World.Difficulty;
    }
}