﻿using System.Linq;
using KludgeBox.Scheduling;

namespace VectorSurvivors;

[GlobalClass]
public partial class EnemyController : CharacterController
{
    private Character _target;
    private Cooldown _aiCooldown = new Cooldown(0.3, CooldownMode.Single);
    /// <inheritdoc />
    public override Vector2 GetInputVector(Character character)
    {
        if (_target.IsValid())
        {
            return _target.Position - character.Position;
        }

        return Vec();
    }

    /// <inheritdoc />
    public override Vector2 GetAimPos(Character character)
    {
        if (_target.IsValid())
        {
            return _target.Position;
        }
        else
        {
            return character.Position + character.Up();
        }
    }

    /// <inheritdoc />
    public override void OnProcess(Character character, double delta)
    {
        _aiCooldown.Update(delta);
        if (_aiCooldown.Use())
        {
            ProcessAi(character);
        }
    }


    private void ProcessAi(Character character)
    {
        _target = World.Players.MinBy(ply => (ply.Position - character.Position).LengthSquared());
    }
}