using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace VectorSurvivors;

public partial class Weapons : ScenesStorage
{
	[Export] [NotNull] public PackedScene Projectile { get; private set; }
	[Export] [NotNull] public PackedScene Ricochet { get; private set; }
	[Export] [NotNull] public PackedScene Wormhole { get; private set; }
	
	public ReadOnlyDictionary<Type, PackedScene> ByType => _weapons.AsReadOnly();
	private Dictionary<Type, PackedScene> _weapons = new();
	/// <inheritdoc />
	public override void _Ready()
	{
		base._Ready();
		_weapons[typeof(ProjectileWeapon)] = Projectile;
		_weapons[typeof(RicochetWeapon)] = Ricochet;
		_weapons[typeof(WormholeWeapon)] = Wormhole;
	}
}