namespace VectorSurvivors;

public partial class XpOrb : Orb
{
	[Export] int Xp { get; set; }
	[Export] [NotNull] public Trail Trail { get; private set; }
	// Called when the node enters the scene tree for the first time.
	public override void _Ready()
	{
		base._Ready();
	}
	
	public static XpOrb Create(int xp)
	{
		var orb = Game.Storage.Entities.XpOrb.Instantiate<XpOrb>();
		orb.Xp = xp;
		return orb;
	}
	
	public virtual void Pick(Player player)
	{
		Trail.ProcessMode = ProcessModeEnum.Inherit;
		base.Pick(player);
	}

	protected override void Apply(Player player)
	{
		base.Apply(player);
		player.AddXp(Xp);

		int sharedXp = (int)Mathf.Ceil(Xp * World.Instance.XpShareFactor);
		foreach (Player otherPlayer in World.Players)
		{
			if (otherPlayer != player)
			{
				otherPlayer.AddXp(sharedXp);
			}
		}

		var dummy = Trail.Drop();
		Trail.Target = dummy;
		dummy.Destruct(Trail.Length);
	}
}