using Godot;
using System;

public partial class CreditsItem : VBoxContainer
{
	[Export] [NotNull] public Label IdLabel { get; private set; }
	[Export] [NotNull] public Label NameLabel { get; private set; }
	[Export] [NotNull] public Button UrlButton { get; private set; }
	
	public string Url { get; private set; }
	public override void _Ready()
	{
		NotNullChecker.CheckProperties(this);
		UrlButton.Pressed += OnUrlButtonPressed;
	}
	
	public void Initialize(string id, string name, string url)
	{
		IdLabel.Text = id+": ";
		NameLabel.Text = name;
		Url = url;
	}
	
	private void OnUrlButtonPressed()
	{
		OS.ShellOpen(Url);
	}
}
