namespace VectorSurvivors;

public partial class DebugOverlay : Control
{
	[Export] [NotNull] public Label HpLabel { get; private set; }
	[Export] [NotNull] public Label MovementSpeedLabel { get; private set; }
	[Export] [NotNull] public Label HpRegenLabel { get; private set; }
	public override void _Ready()
	{
		NotNullChecker.CheckProperties(this);
	}

	// Called every frame. 'delta' is the elapsed time since the previous frame.
	public override void _Process(double delta)
	{
		Threading.DeferTask(() =>
		{
			var character = World.LocalPlayer;
			HpLabel.Text = $"HP: {character.Health:N0}/{character.MaxHealth:N0}";
			MovementSpeedLabel.Text = $"Movement Speed: {character.MovementSpeed:N0}";
			HpRegenLabel.Text = $"Health Regen: {character.HealthRegen:N1}";
		});
	}
}