using System;

namespace VectorSurvivors;

public partial class UpgradableCard : PanelContainer
{
	[Export] [NotNull] public TextureRect Icon { get; private set; }
	[Export] [NotNull] public Label UpgradableInfo { get; private set; }
	[Export] [NotNull] public Label NameLabel { get; private set; }
	[Export] [NotNull] public Label DescriptionLabel { get; private set; }
	[Export] [NotNull] public Label StatsLabel { get; private set; }
	// Called when the node enters the scene tree for the first time.
	public override void _Ready()
	{
		NotNullChecker.CheckProperties(this);
	}

	public void Initialize(IUpgradable upgradeable)
	{
		var target = upgradeable;
		if(!String.IsNullOrWhiteSpace(target.UpgradableName))
		{
			UpgradableInfo.Text = $"ур. {target.Level}/{target.MaxLevel}";
		}
		else
		{
			UpgradableInfo.Text = String.Empty;
		}
        
        
		if(upgradeable.Icon.IsValid())
			Icon.Texture = upgradeable.Icon;
        
		NameLabel.Text = target.UpgradableName;
		DescriptionLabel.Text = target.Description;
		StatsLabel.Text = target.StateInfo;
	}
}