namespace VectorSurvivors;

public partial class WorldInfo : Control
{
	[Export] public Label PlayerLevelLabel { get; private set; }
	[Export] public Label GameTimeLabel { get; private set; }
	[Export] public Label DifficultyLabel { get; private set; }
	[Export] public Label MaxEnemiesLabel { get; private set; }
	
	public override void _Ready()
	{
		NotNullChecker.CheckProperties(this);
	}

	/// <inheritdoc />
	public override void _Process(double delta)
	{
		PlayerLevelLabel.Text = $"Player level: {World.LocalPlayer?.UpgradesComponent?.Level}/{World.LocalPlayer?.UpgradesComponent?.MaxLevel}";
		GameTimeLabel.Text = $"Game time: {World.GameTime:N1} seconds";
		DifficultyLabel.Text = $"Difficulty: {World.Difficulty:N1}";
		MaxEnemiesLabel.Text = $"Max enemies: {World.MaxEnemies}";
	}
}