using KludgeBox.Scheduling;

namespace VectorSurvivors;

public partial class GameName : Label
{
	[Export] public float BrightnessFluctuations = 0.03f;
	[Export] public Color AverageColor;

	private float _fluctuation = 0;
	private float _currentFluctuation = 0;
	private float _step = 0;
	private int _fluctuationFrames = 20;

	private TickingTimer _timer;
	public override void _Ready()
	{
		AverageColor = Col(0.9f - BrightnessFluctuations);
		_timer = new TickingTimer(_fluctuationFrames);
		_timer.OnTimerElapsed += ChangeBrightness;
	}

	// Called every frame. 'delta' is the elapsed time since the previous frame.
	public override void _Process(double delta)
	{
		_timer.AdvanceTick();
		_currentFluctuation += _step;
		var newColor = _currentFluctuation <= 0 ? AverageColor.Darkened(_currentFluctuation) : AverageColor.Lightened(_currentFluctuation);
		LabelSettings.FontColor = newColor;
	}

	private void ChangeBrightness()
	{
		_fluctuation = Rand.Range(-BrightnessFluctuations, BrightnessFluctuations);
		_step = (_fluctuation - _currentFluctuation) / _fluctuationFrames;
	}
}